<?php
/**
* QDL.sk - Functions
*/

if (!function_exists('qdl_sanitizePhoneNumber')) {



//--------------------------- PODPORA HPOS
/*function qdl_isHPOS() {
	// HPOS usage is enabled
	return Automattic\WooCommerce\Utilities\OrderUtil::custom_orders_table_usage_is_enabled();
}*/
function qdl_get_post_meta($post_id, $key, $single = false) {
	$order = wc_get_order($post_id);
	if ($order) {
		$data = $order->get_meta($key);
		if ($single && is_array($data)) {
			return current($data);
		} else {
			return $data;
		}
	}
	return null;
}
function qdl_update_post_meta($post_id, $key, $value) {
	$order = wc_get_order($post_id);
	if ($order) {
		$order->update_meta_data($key, $value);
        $order->save(); // Save the order to apply changes
	}
}
function qdl_delete_post_meta($post_id, $key) {
	$order = wc_get_order($post_id);
	if ($order) {
		$order->delete_meta_data($key);
        $order->save(); // Save the order to apply changes
	}
}
//--------- KONEC





function qdl_sanitizePhoneNumber($s, $stat = 'SK') {
	$prefix = '';
	if ($stat == 'CZ') {
		$prefix = '+420';
	} elseif ($stat == 'SK') {
		$prefix = '+421';
		$s = preg_replace("~^0\s*([1-9])~", "$1", $s); // začínají číslo 0 někdy
	} elseif ($stat == 'DE') {
		$prefix = '+49';
	} elseif ($stat == 'AT') {
		$prefix = '+43';
	} elseif ($stat == 'FI') {
		$prefix = '+358';
	} elseif ($stat == 'PL') {
		$prefix = '+48';
	} elseif ($stat == 'FR') {
		$prefix = '+33';
	} elseif ($stat == 'RO') {
		$prefix = '+40';
	} elseif ($stat == 'HU') {
		$prefix = '+36';
		$s = trim($s);
        $s = preg_replace("~^06\s*([1-9])~", "$1", $s);
	} elseif ($stat == 'CY') {
		$prefix = '+357';
	}
	
	$s = trim($s);
	$s = preg_replace('~\(\s*(0|1)\s*\)~', '', $s); // někdy tam je v závorce předvolba 0, tak to odebereme cele
	$s = preg_replace("~(^00)~", "+", $s);
	$s = preg_replace("~[^0-9\+]~", "", $s);
	
	if (!$s) return '';
	
	if (strpos($s, '+') === FALSE && $prefix != '')
	{
		$numPrefix = substr($prefix, 1);
		if ($numPrefix == substr($s, 0, strlen($numPrefix))) {
			$s = '+' . $s; // only plus was missing
		} else {
			if ($stat == 'AT') {
				if (strlen($s) > 10) {
					// odebereme počáteční nulu
					$s = preg_replace('~^0~', '', $s);
				}
			}
			
			$s = $prefix . $s;
		}
	}
	
	return $s;
}


/**
* Proměnné v JS/CSS souboru
*/
function qdl_handleTemplate($str)
{
	$places = '';
	if (qdl_getConfig('places_SK')) $places.= '|SK';
	if (qdl_getConfig('places_SK_BOX')) $places.= '|SK_BOX';
	if (qdl_getConfig('places_CZ')) $places.= '|CZ';
	if (qdl_getConfig('places_CZ_BOX')) $places.= '|CZ_BOX';
	
	$str = str_replace('{PLACES}', "'".trim($places, '|')."'", $str);
	
	$str = str_replace('{BIG_PACKAGES_ONLY}', qdl_getConfig('big_packages_only') ? 'true' : 'false', $str);
	
	return $str;
}


/**
* API REQUEST
*/
function qdl_request($methodUrl, $data = null)
{
	$username = qdl_getConfig('username');
	$password = qdl_getConfig('gpsw');
	$url = 'https://qdl.sk/myq-api/shipment/' . $methodUrl;
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_USERPWD, ($username . ':' . $password));
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	
	if (!isset($data)) {
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, null);
	} else {
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
	}
	
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	
	$result = curl_exec($ch);
	
	$code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	curl_close($ch);
	
	if ($code !== 200) {
		$data = @json_decode($result);
		if (isset($data->exception) && isset($data->code)) {
			$err = var_export($data->exception, true);
			if (strpos($err, 'Wrong auth credentials.') !== false) {
				$err = 'Nesprávne prihlasovacie údaje k API.';
				throw new Exception($err, $data->code);
			} else {
				throw new Exception(@json_encode($data->exception), $data->code);
			}
		}
		else {
			$result = 'Neznámá chyba: '.$result;
			throw new Exception($result);
		}
	}
	return json_decode($result, true);
}


/**
* Pickup Point by Code
*/
function qdl_getPickupPoint($code)
{	
	$points = qdl_request('api/package-widget/filter', $par = [
		// 1 = JEN BC, 2 = JEN ALZABOX, 3 = OBOJÍ
		"criteria" => [
			"CZ" => 3,
			"SK" => 3,
			"HU" => 3,
		]
	]);
	
	foreach ($points as $p)
	{
		if (strcasecmp($p['code'], $code) == 0)
		{
			return $p;
		}
	}
	return null;
}


/**
* Vrátí popis pobočky (administrace)
*/
function qdl_getPickupPointLabel($code, $withLink = false)
{
	if (!empty($code)) {
		$pobocka = qdl_getPickupPoint($code);
		if (!$pobocka) {
			$str = '<font style="color:red">neexistuje</font>';
		} else {
			$str = '';
			$str.= $pobocka['name'].' - '.$pobocka['city'].', '.$pobocka['street'];
			$pobocka['mapUrl'] = 'https://www.google.com/maps/search/'.urlencode($pobocka['street'].', '.$pobocka['city']);
			if ($withLink && $pobocka['mapUrl']) $str.= ' <a href="'.urldecode($pobocka['mapUrl']).'" target="_blank">(ukáž na mape)</a>';
		}
	}
	else {
		$str = '(žiadne)';
	}
	
	return $str;
}




/**
* Editace balíku v IS
*/
function qdl_editUrl($post_id)
{
	return 'https://www.qdl.sk/'; // prostě seznam objednávek
	
	$id = trim(qdl_get_post_meta($post_id, '_qdl_id', true));
	if (empty($id)) {
		return '#';
	} else {
		// tyhle údaje jsou celkem k ničemu, nedá se tam nic změnit a není tam ani smazání, a není tam ani jít zpět!
		// edit
		return '#';
	}
}

/**
* Stav zásilky
*/
function qdl_historyUrl($post_id) {
	$id = trim(qdl_get_post_meta($post_id, '_qdl_id', true));
	if (empty($id)) {
		return '#';
	} else {
		return '#'; // order-history
	}
}



/**
* Vrátí sledovací čísla
*/
function qdl_getTrackingCodes($post_id)
{
	$trackingCodes = trim(qdl_get_post_meta($post_id, '_qdl_tracking_code', true));
	
	$trackingCodes = $trackingCodes ? explode(";", $trackingCodes) : array(); 
	
	return $trackingCodes;
}


/**
* Vrátí LINK pro sledování
*/
function qdl_trackingLink($mixed)
{
	if (is_array($mixed))
		$mixed = current($mixed);
	else 
		$mixed = current(explode(';', $mixed));
	
	return 'https://www.qdl.sk/tracking?number='.urlencode($mixed);
}



/**
* Match proměnných z konfigurace: shipping_regexp, cod_regexp
*/
function qdl_match($test, $configVarName)
{
	$strList = qdl_getConfig($configVarName);
	if ($strList == '') return true;
	
	$list = preg_split('~\s*[,;]\s*~', $strList); // oddělené čárkama
	
	foreach ($list as $s) {
		if (stripos($test, $s) !== false) return true;
	}
	return false;
}
		

/**
* Zda jde o QDL zásilku
* @param (mixed) - (string) shippingMethod / (int) postId
*/
function qdl_is($mixed)
{
	if (is_numeric($mixed)) {
		$ord = wc_get_order($mixed);
		$dop = '';
		if (!empty($ord)) {
			foreach ($ord->get_shipping_methods() as $m) {
				$dop.= $m['name'].'<br>';
			}
		}
	} else {
		$dop = $mixed;
	}
	return qdl_match($dop, 'shipping_regexp');
}


/**
* Zda je dobírka
* @param (mixed) - (string) paymentMethod / (int) postId
*/
function qdl_isCOD($mixed)
{
	if (is_numeric($mixed)) {
		$ord = wc_get_order($mixed);
		$pla = $ord->get_payment_method_title();
	} else {
		$pla = $mixed;
	}
	return qdl_match($pla, 'cod_regexp');
}



/**
* VRÁTÍ NASTAVENÍ KONFIGURACE
*/
function qdl_getConfig($k = null, $ifNull = null)
{
	static $data;
	if (!isset($data)) {
		$data = (object) array();
		$file = '';
		if (file_exists(__DIR__.'/.config_json')) $file = __DIR__.'/.config_json';
		elseif (file_exists(__DIR__.'/.config_json_default')) $file = __DIR__.'/.config_json_default';
		
		// Podpora pro multisite
		// @note - konfigurace se načítá jen jedenkrát za běhu stránky, takže nelze mít více multisites zároveň!!
		if (is_multisite())
		{
			// aktuálně zvolený multisite (vždycky to ukládám do $_GET)
			if (!isset($_GET['multisite'])) $_GET['multisite'] = get_current_blog_id();
			
			$tempfile = __DIR__.'/.config_multisite'.intval($_GET['multisite']).'_json';
			if (file_exists($tempfile)) {
				// existuje specifická konfigurace
				$file = $tempfile;
			}
		}
		
		if ($file) {
			$content = file_get_contents($file);
			$data = json_decode($content);
		}
		
		if (!empty($data->iban)) {
			if (!preg_match('~[0-9]~', $data->iban)) $data->iban = ''; // není tam žádné číslo
		}
	}
	if ($k) {
		$v =  isset($data->$k) ? $data->$k : $ifNull;
		return $v;
	}
	else {
		return $data;
	}
}
/**
* Uloží konfiguraci
*/
function qdl_setConfig($k, $v)
{
	$data = qdl_getConfig();
	if (!isset($v)) {
		unset($data->$k);
	}
	elseif (isset($data->$k) && $data->$k === $v) {
		// žádná změna
		return false;
	}
	else {
		$data->$k = $v;
	}
	
	$file = __DIR__.'/.config_json';
	
	if (is_multisite())
	{
		// jedná se o konfiguraci pro multisite
		if (!isset($_GET['multisite'])) $_GET['multisite'] = get_current_blog_id();
		
		$file = __DIR__.'/.config_multisite'.intval($_GET['multisite']).'_json';
	}
	
	// uložíme
	return file_put_contents($file, json_encode($data), JSON_PRETTY_PRINT);
}


} // konec functions
