<?php
/**
* QDL - POPUP OKNO - zde se děje veškerý import apod.
*/


ob_start();

// tento skript má umožněn přímý přístup
require_once __DIR__.'/../../../wp-load.php';

include_once ABSPATH . 'wp-admin/includes/plugin.php';


$current_user = wp_get_current_user();
if (!$current_user->ID) {
	// UŽIVATEL MUSÍ BÝT PŘIHLÁŠEN V ADMINU
    die('Nie ste prihlásený v administrácii!');
}
if (!is_plugin_active('woocommerce/woocommerce.php')) {	
	die('Nie je aktivovaný WooCommerce plugin!');
}
//------------------------------


include_once __DIR__.'/functions.php';


if (!isset($_GET['action'])) $_GET['action'] = '';
if (!isset($_GET['post_ids'])) $_GET['post_ids'] = '';

$post_ids = explode(',', trim($_GET['post_ids'], ', '));

foreach ($post_ids as $i => $id) {
	if (!is_numeric($id)) unset($post_ids[$i]);
}



/**
* Vrátí nejbližší možné svozové datum
*/
function qdl_soonestPickup($startDate = null)
{
	// svátky
	$holidayDays = ['1.1.','1.5.','8.5.','5.7.','6.7.','28.9.','28.10.','17.11.','24.12.','25.12.','26.12.'];
	
	$ts = current_time('timestamp');
	
	if (empty($startDate)) $startDate = $ts;
	if (!is_numeric($startDate)) $startDate = strtotime($startDate);
	
	$soonestTime = qdl_getConfig('pickup_time_today') ?: '17:00';
	
	$j = 0;
	do {
		$dayOrd = date("N", $startDate); // 1=Monday, 7=Sunday
		
		// je to dneska a přitom už se to nestíhá objednat
		if (date("Ymd", $startDate) == date("Ymd", $ts) && date("H:i", $ts) > $soonestTime);
		
		// nesmí být svátek
		elseif (in_array(date("d.m.", $startDate), $holidayDays) );
		
		// nesmí být sobota ani neděle
		elseif ($dayOrd == 6 || $dayOrd == 7);
		
		else
			break; // vše ok
		
		if ($j++ > 30) break; // nějaká chyba
	}
	while ($startDate+= 24*3600); // posuneme na další den
	
	return date("Y-m-d", $startDate);
}


/**
* BLOK pro výběr svozového data
*
* @param (string) $heading
* @param (array) $dates2highlight - dates[Y-m-d] = Y-m-d
*/
function qdl_chooseDate($heading, $dates2highlight = null) {
	?>
	<div class="text-center pt-4">
	<form method="post">
	<?php
	foreach ($_POST as $k => $v) echo '<input type="hidden" name="'.$k.'" value="'.htmlspecialchars($v).'">';
	?>
	<p><?= $heading ?></p>
	<?php
	//$days = array('Pondělí', 'Úterý', 'Středa', 'Čtvrtek', 'Pátek', 'Sobota', 'Neděle'); // nebudu řešit locale
	$days = array('Pondelok', 'Utorok', 'Streda', 'Štvrtok', 'Piatok', 'Sobota', 'Nedeľa');
	
	$printed = array();
	$i = 0;
	do {
		$Ymd = qdl_soonestPickup( strtotime('+'.$i.' days') );
		$i++;
		if (isset($printed[$Ymd])) continue;
		$printed[$Ymd] = $Ymd;
	}
	while (count($printed) < 10);
	
	if (is_array($dates2highlight)) {
		$printed = $dates2highlight;
		$printed = array_unique($printed);
		ksort($printed);
		
		echo '<p><button type="submit" name="pickup_date" value="" class="btn btn-secondary col-8">Chcem podať všetky označené zásielky</button></p>';
	}
	
	$first = true;
	foreach ($printed as $Ymd) {
		$isBig = (!isset($dates2highlight) && $first) || isset($dates2highlight[$Ymd]);
		$first = false;
		$dayname = $days[ date("N", strtotime($Ymd)) -1 ];
		echo '<p><button type="submit" name="pickup_date" value="'.$Ymd.'" class="btn btn-secondary col-'.($isBig ? 8 : 6).'">'.$dayname.'&nbsp; '.date("d. m. Y", strtotime($Ymd)).'</button></p>';
	}
	?>
	</form>
	</div>
	<?php
}


/**
* BLOK pro výběr IBAN účtu
*
* @param (string) $heading
*/
function qdl_chooseIban($heading, $ibans) {
	?>
	<div class="text-center pt-4">
	<form method="post">
	<?php
	foreach ($_POST as $k => $v) echo '<input type="hidden" name="'.$k.'" value="'.htmlspecialchars($v).'">';
	?>
	<p><?= $heading ?></p>
	<?php
	foreach ($ibans as $ibanArray) {
		[$iban, $name] = $ibanArray;
		echo '<p><button type="submit" name="iban" value="'.$iban.'" class="btn btn-secondary col-6"><b>'.$name.'</b><br><small>'.$iban.'</small></button></p>';
	}
	?>
	</form>
	</div>
	<?php
}

	
	

/**
* JSON AKCE
*/
if (!empty($_GET['action_json']))
{
	while(@ob_get_clean()); // pro jistotu
	header("Content-type: application/json; charset=utf-8");
	
	$post_id = intval($_GET['post_id']);
	
	$canUpdate = !qdl_getTrackingCodes($post_id);
	
	$ret = array();
	
	/**
	* ULOŽENÍ HMOTNOSTI U JEDNOHO BALÍKU (AJAX)
	*/
	if ($_GET['action_json'] == 'save_weight')
	{
		// ošetříme hmotnosti
		$str = $_GET['weight'];
		$str = str_replace('a', '+', $str);
		
		$weights = array();
		foreach (explode("+", $str) as $weight) {
			$weight = preg_replace('~[^0-9\.,+]~', '', $weight);
			$weight = str_replace('.', ',', $weight);
			$weight = trim($weight, ' ,');
			if (preg_match('~^([1-9]|0,)~', $weight)) {
				$weights[] = $weight;
			}
		}
		$weights = (string) implode('+', $weights);
		
		if ($canUpdate) {
			qdl_update_post_meta($post_id, '_qdl_packages_weight', $weights);
		} else {
			$weights = qdl_get_post_meta($post_id, '_qdl_packages_weight', true);
		}
		
		$ret['weight'] = $weights;
	}
	/**
	* ULOŽENÍ POZNÁMKY U ŘIDIČE U JEDNOHO BALÍKU (AJAX)
	*/
	elseif ($_GET['action_json'] == 'save_driver_note')
	{
		$str = trim($_GET['driver_note']);
		$str = preg_replace('["\']', '', $str); // pro jistotu
		
		if ($canUpdate) {
			qdl_update_post_meta($post_id, '_qdl_driver_note', $str);
		} else {
			$str = qdl_get_post_meta($post_id, '_qdl_driver_note', true);
		}
		
		$ret['driver_note'] = $str;
	}
	
	echo json_encode($ret);
	exit;
}


###############################################################

/**
* Chyba
*/
function qdl_error($str) {
	echo '<div class="alert alert-danger" role="alert">'.$str.'</div>';
}
/**
* OK
*/
function qdl_ok($str) {
	echo '<div class="alert alert-success">'.$str.'</div>';
}



/**
* HTML HEADING
*/
function heading($s = '')
{
	echo '<!doctype html>
	<html lang="cs">
	<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>QDL - '.$s.'</title>
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" crossorigin="anonymous">
	<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.2/css/all.css" integrity="sha384-oS3vJWv+0UjzBfQzYUhtDYW+Pj2yciDJxpsK1OYPAYjqT085Qq/1cq5FLXAZQ7Ay" crossorigin="anonymous">
	<!--[if lt IE 9]>
	<script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
	<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
	<![endif]-->
	<script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
	<style>
	HEADER{
		box-shadow: 0 0 5px 2px rgba(0,0,0,.3);
		background: #eee;
		border-bottom: 2px solid #47484C;
		text-align: center;
		padding-top: 5px;
	}
	HEADER SPAN{
		vertical-align: middle;
		display: inline-block;
		margin-left: 21px;
		padding-left: 18px;
		border-left: 1px solid #5fbb46;
		line-height: 1.4;
		font-weight: bold;
		padding-top: 6px;
		padding-bottom: 6px;
	}
	.form-group {
		margin-bottom: 1.25rem;
	}
	.form-group.row{
			margin-bottom: 0.3rem;
	}
	.form-group LABEL{
		font-weight:bold;
		color:#444;
	}
	.form-checks-inline .form-check{
		display: inline-block;
		border: 1px solid #ccc;
		border-radius: 5px;
		padding: 7px 7px 7px 1.7rem;
		line-height: 20px;
		cursor:pointer;
	}
	.form-checks-inline .form-check:hover{
		background:#eee;
	}
	.form-checks-inline .form-check LABEL:hover{
		background:initial;
	}
	.form-check{
		line-height: 19px;
		padding-top: 5px;
		padding-bottom: 5px;
		padding-left:1.5rem;
	}
	.form-check INPUT{
		cursor:pointer;
	}
	.form-check LABEL{
		font-weight:normal;
		cursor:pointer;
	}
	.form-check LABEL:hover {
		background: #eee;
	}
	.form-check-input.mytoggl:checked + LABEL{
		font-weight:Bold;
	}
	.form-check-input:checked + LABEL{
		color:#0033cc;
	}
	BODY.loading{
		overflow:hidden;
	}
	BODY.loading:before{
		content:\'\';
		display:flex;position:fixed;top:0;left:0;bottom:0;right:0;z-index:1080;
		background:rgba(255,255,255,0.4);	
	}
	BODY.loading:after{
		content: \'\';
		display: block;
		position: fixed;
		left: 0;
		top: 0;
		right: 0;
		margin: auto;
		bottom: 0;
		z-index:1081; /* nad modal */
		width: 250px;
		height: 250px;
		box-sizing: border-box;
		background: url(\'data:image/svg+xml,<svg width="100%" height="100%" viewBox="0 0 38 38" xmlns="http://www.w3.org/2000/svg"><defs><linearGradient id="gradient" x1="0" y1="0" x2="1" y2="0"><stop offset="0" stop-color="%23000000" stop-opacity="0"/><stop offset="1" stop-color="%23000000" stop-opacity="1"/></linearGradient></defs><path stroke="url(%23gradient)" vector-effect="non-scaling-stroke" stroke-width="2px" fill="none" fill-rule="evenodd" d="M2,19a17,17 0 1,1 34,0"></path><path stroke="%23000000" vector-effect="non-scaling-stroke" stroke-width="2px" fill="none" fill-rule="evenodd" d="M2,19a17,17 0 1,0 34,0"></path></svg>\');
		animation: fadein 1s, spinnin 620ms infinite linear;
	}
	@keyframes fadein{from{opacity:0}to{opacity:1}}
	@keyframes spinnin{ 100% {transform:rotate(360deg);}}
	</style>
	<link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
	</head>
	<body>';

	echo '<header><h1 class="h4 p-2"><img src="logo.png" width="126" height="52" alt="QDL"><span>'.$s.'</span></h1></header><main class="py-3 px-1"><div class="container-fluid">';	
}

/**
* HTML FOOTER
*/
function footer() {
	echo '</div></main>';
	echo '</body></html>';
}


##################################################

if ($_GET['action'] == 'configuration')
{
	//---- HLAVNÍ KONFIGURACE
	heading("Konfigurácia");
	
	
	if ($_POST)
	{
		// uložíme konfiguraci
		
		$keys = array(
			'pickup_on', 'iban', 'sender_on', 'extra_insurance', 'extra_gdd', 'extra_d12', 'extra_sAdvice', 'extra_tAdvice'
		);
		foreach ($keys as $k) {
			if (!isset($_POST[$k])) $_POST[$k] = ''; // E_NOTICE
		}
		
		qdl_setConfig('username', trim($_POST['username']));
		qdl_setConfig('gpsw', trim($_POST['gpsw']));
		qdl_setConfig('shipping_regexp', trim($_POST['shipping_regexp']));
		qdl_setConfig('cod_regexp', trim($_POST['cod_regexp']));
		qdl_setConfig('id_sender', trim($_POST['id_sender']));
		qdl_setConfig('label_type', trim($_POST['label_type']));
		
		qdl_setConfig('pickup_on', trim($_POST['pickup_on']));
		qdl_setConfig('pickup_name', trim($_POST['pickup_name']));
		qdl_setConfig('pickup_street', trim($_POST['pickup_street']));
		qdl_setConfig('pickup_zip', trim($_POST['pickup_zip']));
		qdl_setConfig('pickup_city', trim($_POST['pickup_city']));
		qdl_setConfig('pickup_phone', trim($_POST['pickup_phone']));
		qdl_setConfig('pickup_email', trim($_POST['pickup_email']));
		
		qdl_setConfig('sender_on', trim($_POST['sender_on']));
		qdl_setConfig('sender_name', trim($_POST['sender_name']));
		qdl_setConfig('sender_street', trim($_POST['sender_street']));
		qdl_setConfig('sender_city', trim($_POST['sender_city']));
		qdl_setConfig('sender_zip', trim($_POST['sender_zip']));
		
		qdl_setConfig('extra_insurance', !!$_POST['extra_insurance']);
		qdl_setConfig('extra_gdd', !!$_POST['extra_gdd']);
		qdl_setConfig('extra_d12', !!$_POST['extra_d12']);
		qdl_setConfig('extra_sAdvice', !!$_POST['extra_sAdvice']);
		qdl_setConfig('extra_tAdvice', !!$_POST['extra_tAdvice']);
		
		qdl_setConfig('default_weight', $_POST['default_weight']);
		
		
		$ptt = trim($_POST['pickup_time_today']);
		if (!preg_match('~^\d+:\d+$~', $ptt)) {
			$ptt = '';
		}
		qdl_setConfig('pickup_time_today', $ptt);
		
		
		qdl_setConfig('iban', trim($_POST['iban']));
		
		$j = 2;
		if (isset($_POST['multiple_ibans'])) {
			for ($i=2; $i<=9; $i++) {
				$iban = trim($_POST['iban'.$i]);
				if ($j == 2 && empty(trim($_POST['iban']))) {
					// uložíme jako hlavní IBAN
					qdl_setConfig('iban', $iban);
					$_POST['iban'] = $iban;
				} elseif (!empty($iban)) {
					qdl_setConfig('iban'.$j, $iban);
					qdl_setConfig('iban_name'.$j, $_POST['iban_name'.$i]);
					$j++;
				}
			}
		}
		for ($j; $j<=9; $j++) {
			qdl_setConfig('iban'.$j, '');
		}
		
		$justSaved = true;
	}
	?>
	<form method="post">
	
		<?
		//---------------- VÝBĚR MULTISITE
		if (is_multisite())
		{
			// aktuálně zvolený multisite (vždycky to ukládám do $_GET)
			if (!isset($_GET['multisite'])) $_GET['multisite'] = get_current_blog_id();
			?>	
			<div class="form-group mb-3 text-center" style="background:#666;padding:1rem;margin: -16px calc(-0.25rem - 15px) 0;box-shadow: 0 3px 2px rgba(0,0,0,.2);position: sticky;    top: 0; z-index: 10;">
				<label for="username" class="text-white">Konfigurácia pre multisite:</label>
				<select class="form-control w-auto d-inline-block ml-1 font-weight-bold" onchange="$(body).addClass('loading');location.href='popup.php?action=configuration&multisite='+this.value;">
				<?
				foreach (get_sites() as $ws)
				{
					echo '<option value="'.$ws->blog_id.'"'.(isset($_GET['multisite']) && $_GET['multisite'] == $ws->blog_id ? ' selected' : '').'>'.$ws->path.'</option>';
				}
				?>
				</select>
			</div>
			<?
		}
		
		if (isset($justSaved)) {
			qdl_ok('<div class="text-center font-weight-bold msgok">Konfigurácia bola uložená &#128578;</div>');
		}
		?>
		<div class="form-group mb-3">
			<label for="username">API užívateľské meno:</label>
			<input type="text" class="form-control" id="username" name="username" value="<?= esc_attr(qdl_getConfig('username')); ?>">
		</div>
		<div class="form-group mb-3">
			<label for="gpsw">API heslo:</label>
			<input type="text" class="form-control" id="gpsw" name="gpsw" value="<?= esc_attr(qdl_getConfig('gpsw')); ?>">
		</div>
		<div class="form-group mb-3">
			<label for="id_sender">ID adresy odosielateľa:</label>
			<input type="text" class="form-control" id="id_sender" name="id_sender" value="<?= esc_attr(qdl_getConfig('id_sender')); ?>">
			<small class="form-text text-muted">
				<p>ID pridelí QDL, je jedinečné pre každého zákazníka.</p>
			</small>
		</div>
		
		<div class="form-group form-check mb-3">
			<input type="checkbox" class="form-check-input mytoggl" id="checkPickup" name="pickup_on" value="1"<?= qdl_getConfig('pickup_on') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="checkPickup">Iná adresa pre zvoz (nepovinné)</label>
		</div>
		
		<div class="form-group" data-id="checkPickup">
			<div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_name">Meno:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_name" name="pickup_name" value="<?= qdl_getConfig('pickup_name'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_street">Ulica:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_street" name="pickup_street" value="<?= qdl_getConfig('pickup_street'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_zip">PSČ:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_zip" name="pickup_zip" pattern="^[0-9]{5}$" value="<?= qdl_getConfig('pickup_zip'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_city">Mesto:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_city" name="pickup_city" value="<?= qdl_getConfig('pickup_city'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_phone">Telefón:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_phone" name="pickup_phone" value="<?= qdl_getConfig('pickup_phone'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="pickup_phone">Email:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="pickup_email" name="pickup_email" value="<?= qdl_getConfig('pickup_email'); ?>">
					</div>
				</div>
			</div>
		</div>
		
		<div class="form-group form-check">
			<input type="checkbox" class="form-check-input mytoggl" id="checkSender" name="sender_on" value="1"<?= qdl_getConfig('sender_on') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="checkSender">Krycia adresa odosielateľa (nepovinné)</label>
		</div>
		
		<div class="form-group" data-id="checkSender">
			<div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_name">Meno:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_name" name="sender_name" value="<?= qdl_getConfig('sender_name'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_street">Ulica:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_street" name="sender_street" value="<?= qdl_getConfig('sender_street'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_zip">PSČ:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_zip" name="sender_zip" pattern="^[0-9]{5}$" value="<?= qdl_getConfig('sender_zip'); ?>">
					</div>
				</div>
				<div class="form-group row">
					<label class="col-3 text-right align-self-center my-0" for="sender_city">Mesto:</label>
					<div class="col-9 pl-0">
						<input type="text" class="form-control" id="sender_city" name="sender_city" value="<?= qdl_getConfig('sender_city'); ?>">
					</div>
				</div>
			</div>
		</div>
		
		<hr>
		
		
		<div class="form-group">
			<label for="shipping_regexp">Názov dopravy pre aktiváciu pluginu:</label>
			<input type="text" class="form-control" id="shipping_regexp" name="shipping_regexp" style="font-family:Monospace,Courier New;" value="<?= esc_attr(qdl_getConfig('shipping_regexp')); ?>" placeholder="">
			<small class="form-text text-muted">
				<p>Panel QDL sa zobrazí ak doprava u objednávky bude obsahovať jeden z týchto reťazcov.<br>Pokiaľ necháte prázdne, bude sa panel ukazovať vždy.</p>
			</small>
		</div>
		
		<div class="form-group">
			<label for="cod_regexp">Názov platby v prípade dobierky:</label>
			<input type="text" class="form-control" id="cod_regexp" name="cod_regexp" style="font-family:Monospace,Courier New;" value="<?= esc_attr(qdl_getConfig('cod_regexp')); ?>" placeholder="" required>
			<small class="form-text text-muted">
				<p>Ak názov platby bude u objednávky obsahovať jeden z týchto reťazcov, použije sa pri importe balíka dobierka.<br>Predvolené sú tieto slová: dobierka, dobierku, dobierkou, pri prevzatí, v hotovosti.<br>Ak necháte prázdne použije sa dobierka vždy.</p>
			</small>
		</div>
		
		
		<hr>
		
		<div class="form-group mb-3">
			<label for="iban">IBAN číslo účtu:</label>
			<input type="text" class="form-control" id="iban" name="iban" value="<?= esc_attr(qdl_getConfig('iban')); ?>" placeholder="SK">
			<small class="form-text text-muted">
				<p>Číslo účtu pre dobierku. Len pre zásielky doručované na SK.</p>
			</small>
		</div>
		
		<?php
		$multipleIbans = false;
		for ($i=2; $i<=9; $i++) {
			if (!empty(qdl_getConfig('iban'.$i))) $multipleIbans = true;
		}
		?>
		<div class="form-group form-check">
			<input type="checkbox" class="form-check-input mytoggl" value="1" name="multiple_ibans" id="multiple_ibans"<?= $multipleIbans ? ' checked' : ''; ?>>
			<label class="form-check-label" for="multiple_ibans">Mám ďalšie bankové účty a budem si vyberať podľa potreby</label>
		</div>
		
		<div class="form-group" data-id="multiple_ibans">
			<div>
				<div class="form-group row font-weight-bold">
					<div class="col-8 pr-1">Ďalšie IBAN číslo účtu</div>
					<div class="col-4 pl-0">Pomenovanie</div>
				</div>
				<?php for ($i=2; $i<=9; $i++) { ?>
				<div class="form-group row">
					<div class="col-8 pr-1">
						<input type="text" class="form-control" name="iban<?= $i ?>" value="<?= qdl_getConfig('iban'.$i); ?>" placeholder="SK">
					</div>
					<div class="col-4 pl-0" for="iban<?= $i ?>">
						<input type="text" class="form-control" style="color:purple" name="iban_name<?= $i ?>" value="<?= qdl_getConfig('iban_name'.$i); ?>" placeholder="IBAN č. <?= $i ?>">
					</div>
				</div>
				<?php } ?>
			</div>
		</div>
		
		<hr>
		
		<div class="form-group">
			<label>Extra služby:</label>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_insurance" id="extra_insurance"<?= qdl_getConfig('extra_insurance') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_insurance">Poistenie balíka</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_gdd" id="extra_gdd"<?= qdl_getConfig('extra_gdd') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_gdd">Garantované doručenie (len CZ/SK)</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_d12" id="extra_d12"<?= qdl_getConfig('extra_d12') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_d12">Doručenie do 12h (len CZ/SK)</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_sAdvice" id="extra_sAdvice"<?= qdl_getConfig('extra_sAdvice') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_sAdvice">SMS avízo (len CZ/SK)</label>
			</div>
			
			<div class="form-check">
			<input type="checkbox" class="form-check-input" value="1" name="extra_tAdvice" id="extra_tAdvice"<?= qdl_getConfig('extra_tAdvice') ? ' checked' : ''; ?>>
			<label class="form-check-label" for="extra_tAdvice">Telefonické avízo (len CZ/SK)</label>
			</div>
		</div>
		
		<hr>
		<div class="form-group">
			<label for="label_type">Formát štítkov:</label>
			<select class="form-control" id="label_type" name="label_type">
				<option>A4</option>
				<option<?= qdl_getConfig('label_type') == 'ZEBRA' ? ' selected' : ''; ?>>ZEBRA</option>
				<!-- <option<?= qdl_getConfig('label_type') == 'ZPL' ? ' selected' : ''; ?>>ZPL</option>
				<option<?= qdl_getConfig('label_type') == 'ZPL300' ? ' selected' : ''; ?>>ZPL300</option> -->
			</select>
		</div>
		<hr>
		
		<div class="form-group">
			<label for="default_weight">Predzvolená hmotnosť:</label>
			<div class="input-group">
				<input type="number" class="form-control input-group-prepend" id="default_weight" name="default_weight" value="<?= esc_attr(qdl_getConfig('default_weight')); ?>"><span class="input-group-text input-group-append" >Kg</span>
			</div>
			<small class="form-text text-muted">
				<p>Pre ignoráciu hmotnosti zadajte 0 (hmotnosť potom nebude nutné vyplňovať).</p>
			</small>
		</div>
		<hr>
		
		<div class="form-group">
			<label for="pickup_time_today">Neponúkať zvoz na dnešný deň po čase:</label>
			<div class="input-group">
				<input type="time" class="form-control" id="pickup_time_today" name="pickup_time_today" value="<?= esc_attr(qdl_getConfig('pickup_time_today')) ?: '17:00'; ?>">
			</div>
		</div>
		
		<br><br><br>
		
		<div class="text-right" style="position:sticky;bottom:0;background:linear-gradient(to bottom,rgba(255,255,255,0),rgba(0,0,0,.2));margin:0 calc(-0.25rem - 15px) -16px;padding:0 15px 15px 15px;pointer-events:none">
			<button type="submit" class="btn btn-primary shadow-sm" style="pointer-events: all;z-index: 10;position: relative;">Uložiť nastavenie</button>
		</div>
	</form>
	
	<script>
	$('#checkPickup').on('click', function(){
		$('#id_sender').attr('readonly', $(this).is(':checked'));
	}).each(function(){
		var o = $(this);
		if (o.is(':checked')) o.triggerHandler('click');
	});
	
	$('.mytoggl').on('click', function(){
		var o = $(this);
		$('[data-id='+o.attr('id')+']').toggle( o.is(':checked') );	
	}).each(function(){
		var o = $(this);
		if (!o.is(':checked')) o.triggerHandler('click');
	});
	
	setTimeout(function(){
		$('.msgok').parent().slideUp();
	}, 2000);
	
	$('.form-check').click(function(e){
		if ($(e.target).closest('LABEL,INPUT').length) return;
		var inp = $(this).find('INPUT');
		if (inp.length) inp.prop('checked', !inp.prop('checked'));
	});
	</script>
	
	<?php

}
elseif ($_GET['action'] == 'create_pickup')
{
	/*
	//---- OBJEDNÁVKA ZVOZU -- samostatně nepoužívám
	heading('Objednávka zvozu');
	exit;
	*/
}
elseif ($_GET['action'] == 'pickuplist')
{
	//--- PODACÍ ARCH
	
	if (!empty($_REQUEST['pickup_date']))
	{
		// chce vytisknout arch podle data podání => najdeme zásilky importované pro daný datum!
		$orders = wc_get_orders( array(
			'limit'        => -1,
			'orderby'      => 'date',
			'order'        => 'DESC',
			'meta_key'     => '_qdl_pickup_date',
			'meta_value' => $_REQUEST['pickup_date']
		));
		
		$post_ids = [];
		foreach ($orders as $post) {
			$post_id = $post->get_id();
			$post_ids[] = $post_id;
		}
	}
	
	
	
	$all_codes = array();
	$dates = array();
	foreach ($post_ids as $post_id)
	{
		$date = qdl_get_post_meta($post_id, '_qdl_pickup_date', $single = true);
		$codes = qdl_get_post_meta($post_id, '_qdl_tracking_code', $single = true);
		$dates[] = $date;
		
		if (empty($codes)) {
			heading('Podací hárok');
			qdl_error('Objednávka #'.$post_id.' musí byť najskôr importovaná.');
			exit;
		}
		else {
			$all_codes = array_merge($all_codes, explode(";", $codes));
		}
	}
	
	if (count($dates) > 1 && !isset($_REQUEST['pickup_date']))
	{
		// musí vybrat datum
		heading('Podací hárok');
		qdl_chooseDate('Označené zásielky majú rôzne dátumy zvozu.<br> Vyberte dátum zvozu:', $dates);
		exit;
	}
	
	
	try {
		$result = qdl_request('protocol', ["shipments" => $all_codes]);
		
		if (!isset($result['pdf'])) throw new Exception('Neznámá chyba');
		
		$pdfContent = base64_decode($result['pdf']);
		
		
		// a ještě objednáme svoz
		// toto objedná svoz pro všechny otevřené zásilky
		$resultPickup = qdl_request('request-pickup', []);
		
		header("Content-Type: application/pdf");
		header('Content-Disposition: inline; filename="harok_'.date('dmY_Hi', current_time('timestamp')).'.pdf"');
		echo $pdfContent;
		exit;
	}
	catch (Exception $e) {
		heading('Podací hárok');
		qdl_error('API: '.$e->getMessage());
		exit;
	}
	
	heading('Podací hárok');
	qdl_error('Žiadna objednávka na tlač.');
}
elseif ($_GET['action'] == 'labels')
{
	//--- TISK PDF ŠTÍTKŮ
	heading('PDF štítky');
	
	$codes = trim((string) $_REQUEST['codes'], ';');
	$codes = $codes ? explode(";", $codes) : array();
	
	if (empty($codes)) {
		qdl_error('Žiadne zásielky k tlači.');
	}
	else {
		try {
			while(@ob_end_clean());
			
			try {
				$result = qdl_request('get-label', [
					"shipments" => $codes,
					"type" => qdl_getConfig('label_type') ?: 'A4', // A4, ZEBRA
					"position" => min(4, max(1, $_REQUEST['pos'])),
				]);
			} catch (Throwable $e) {
				// tohle je vážná chyba
				qdl_error($e->getMessage());
			}
			
			if (!isset($result['data'])) throw new Exception('Neznámá chyba');
			
			$pdfContent = base64_decode($result['data']);
			header("Content-Type: application/pdf");
			header('Content-Disposition: inline; filename="stitky_'.date('dmY_Hi', current_time('timestamp')).'.pdf"');
			echo $pdfContent;
			exit;
		}
		catch (Exception $e) {
			qdl_error('API: '.$e->getMessage());
		}
	}
	
}
elseif ($_GET['action'] == 'import')
{
	//--- IMPORT BALÍKŮ
	heading('Import balíkov');
	
	
	// IBAN účty
	$ibans = [];
	for ($i=1; $i<=9; $i++) {
		$iban = qdl_getConfig('iban'.($i == 1 ? '' : $i));
		$iban_name = qdl_getConfig('iban_name'.($i == 1 ? '' : $i));
		if (!empty($iban)) {
			if (empty($iban_name)) $iban_name = $i == 1 ? 'Hlavný účet' : 'IBAN č.'.$i;
			$ibans[] = [$iban, $iban_name];
		}
	}
	
	
	if (empty($post_ids))
	{
		qdl_error('Neboli vybrané žiadne objednávky.');
	}
	elseif (empty($_POST['pickup_date']) || !strtotime($_POST['pickup_date']))
	{
		// musí vybrat datum svozu
		qdl_chooseDate('Zvoľte dátum zvozu:');
		exit;
	}
	elseif (count($ibans) > 1 && empty($_POST['iban']))
	{
		// musí vybrat IBAN účet
		qdl_chooseIban('Zvoľte bankový účet pre dobierku:', $ibans);
		exit;
	}
	else
	{
		// datum svozu
		$pickup_date = empty($_POST['pickup_date']) ? date("Y-m-d", current_time('timestamp')) : $_POST['pickup_date'];
		$pickup_date = date("d.m.Y", strtotime($pickup_date));
		
		
		$imported = '';
		$kurierOrders = [];
		
		$rq_post_ids = array_combine($post_ids, $post_ids);
		foreach ($rq_post_ids as $post_id)
		{
			// IMPORT NOVÉ ZÁSILKY
			
			if (!qdl_is($post_id)) {
				// jiný typ dopravy
				continue;
			}
			
			$ord = wc_get_order($post_id);
			
			if (!$ord) continue; // neexistuje
			
			// print_r( get_class_methods($ord) );
			
			$trackingCodes = qdl_get_post_meta($post_id, '_qdl_tracking_code', $single = true);
			
			if ($trackingCodes) {
				//-------- už bylo dříve importováno!
				
				// zjistím stav této zásilky
				
				try {
					$result = qdl_request('status-history', ['shipmentNumbers' => [ current(explode(";", $trackingCodes)) ] ]);
				} catch (Throwable $e) {
					// tohle je vážná chyba
					qdl_error($e->getMessage());
					break; // konec
				}
				
				$last_info = current($result);
				$history = [];
				if (isset($last_info['history'])) {
					$history = $last_info['history'];
					if (is_array($history) && !isset($history['id'])) {
						$history = current($history); // první záznam je nejnovější
					}
				}
				if (empty($history) || $history['id'] == 19 || $history['id'] == 21) {
					// u nových balíků není historie
					// čeká / připravená na svoz => nebudu posílat do API
					$imported.= ($imported == '' ? '' : ';').$trackingCodes;
					unset($rq_post_ids[$post_id]); // nebudu posílat znovu do API
					qdl_error('Táto objednávka už bola importovaná!');
					continue;
				}
			}
			
			
			// pokud je v konfiguraci nastaveno číslo, tak je hmotnost nepovinná
			$defaultWeight = qdl_getConfig('default_weight');
			$hasDefaultWeight = true;
			if (!is_numeric($defaultWeight)) {
				$defaultWeight = '0';
				$hasDefaultWeight = false;
			}
			
			$weights = qdl_get_post_meta($post_id, '_qdl_packages_weight', $single = true);
			
			// Seznam balíků v zásilce - rozměry nedáváme, hmotnost v kg
			$packages = array();
			$weights = $weights ? explode('+', $weights) : array($defaultWeight);
			foreach ($weights as $weight) {
				if ($weight > 0 || $hasDefaultWeight) {
					$packages[] = array(
						'weight' => (float) str_replace(',', '.', $weight) // hmotnost_kg
					);
				}
			}
			
			
			if (empty($packages)) {
				$withError = true;
				qdl_error('Objednávka #'.$post_id.' preskočená. Nutné doplniť hmotnosť balíka.');
				continue;
			}
			
			// PŘÍJEMCE
			$fullname = trim($ord->get_shipping_first_name().' '.$ord->get_shipping_last_name().' '.$ord->get_shipping_company());
			$street = trim($ord->get_shipping_address_1().' '.$ord->get_shipping_address_2());
			$city = trim($ord->get_shipping_city());
			$zip = trim($ord->get_shipping_postcode());
			$country = trim($ord->get_shipping_country());
			
			if (!$fullname) $fullname = trim($ord->get_billing_first_name().' '.$ord->get_billing_last_name().' '.$ord->get_billing_company());
			if (!$street) $street = trim($ord->get_billing_address_1().' '.$ord->get_billing_address_2());
			if (!$city) $city = trim($ord->get_billing_city());
			if (!$zip) $zip = trim($ord->get_billing_postcode());
			if (!$country) $country = trim($ord->get_billing_country());
			if (!$country) $country = 'SK';
			
			
			
			// poznámka řidiči
			$driver_note = qdl_get_post_meta($post_id, '_qdl_driver_note', $single = true);
			
			
			// DOBÍRKA
			$COD = 0;
			if (qdl_isCOD($ord->get_payment_method_title())) {
				// dobírka, měna, variabilní symbol
				// $ord->get_currency() -- měna se považuje za takovou jaká je v dané zemi
				$COD = $ord->get_total();
			}
			
			
			// REFERENCE ZÁSILKY
			$order = new WC_Order($post_id);
			$reference = trim(str_replace('#', '', $order->get_order_number()));
			
			$pickup_on = qdl_getConfig('pickup_on');
			$pickup_name = qdl_getConfig('pickup_name');
			$pickup_street = qdl_getConfig('pickup_street');
			$pickup_zip = qdl_getConfig('pickup_zip');
			$pickup_city = qdl_getConfig('pickup_city');
			$pickup_phone = qdl_getConfig('pickup_phone');
			$pickup_email = qdl_getConfig('pickup_email');
			$pickupAddress = $pickup_on && ($pickup_name || ($pickup_street && $pickup_zip && $pickup_city));
			
			
			$sender_on = qdl_getConfig('sender_on');
			$sender_name = qdl_getConfig('sender_name');
			$sender_street = qdl_getConfig('sender_street');
			$sender_zip = qdl_getConfig('sender_zip');
			$sender_city = qdl_getConfig('sender_city');
			$senderMask = $sender_on && ($sender_name || ($sender_street && $sender_zip && $sender_city));
			if (!$senderMask) {
				$sender_name = $sender_street = $sender_zip = $sender_city = '';
			}
			
			// variabilní symbol musí mít jenom číslice
			$variable_symbol = preg_replace('~[^0-9]~', '', $reference);
			if (strlen($variable_symbol) > 10) {
				$variable_symbol = substr($variable_symbol, -10); // posledních 10 číslic
			}
			
			
			$pickup_zip = str_replace(" ", "", $pickup_zip);
			$sender_zip = str_replace(" ", "", $sender_zip);
			
			if ($pickupAddress) {
				// vlastní adresa svozu
				$sender_block = [
					"name" => $pickup_name,
					"street" => $pickup_street,
					"zip" => $pickup_zip,
					"city" => $pickup_city,
					"country" => "Slovensko",
					"phone" => qdl_sanitizePhoneNumber($pickup_phone, 'SK'),
					"contactPerson" => "",
					"mail" => $pickup_email,
				];
			}
			else {
				// ID adresa svozu
				$sender_block = [
					"id" => qdl_getConfig('id_sender')
				];
			}
			
			//---- krycí adresa
			$sender_block['type'] = $senderMask ? 1 : 0; // krycia adresa
			$sender_block['label'] = [
				"name" => $sender_name,
				"street" => $sender_street,
				"zip" => $sender_zip,
				"city" => $sender_city,
				"country" => $senderMask ? 'SK' : '', // vždy SK
			];
			
			
			$kurierOrder = array(
	            "clientReference" => $reference,
	            "pickupdate" => $pickup_date, // den svozu
	            "cod" => $COD,
	            "codVarSym" => $variable_symbol,
				'codIban' => !empty($_POST['iban']) ? $_POST['iban'] : qdl_getConfig('iban'),
	            "note" => $driver_note,
	            "sender" => $sender_block,
	            "recipient" => [
	                "name" => $fullname,
	                "street" => $street,
	                "zip" => $zip,
	                "city" => $city,
	                "country" => $country,
	                "phone" => qdl_sanitizePhoneNumber($ord->get_billing_phone(), $country),
	                "contactPerson" => "",
	                "mail" => $ord->get_billing_email()
	            ],
	            "items" => $packages,
	            "insurance" => [
	                "enabled" => qdl_getConfig('extra_insurance') ? 1 : 0, // pojištění
	                "shipmentValue" => $ord->get_total()
	            ],
	            "services" => [
	                "g24" => qdl_getConfig('extra_gdd', false), // gdd -garantované doručenie 1/0 povolené len pre SK
	                "t12" => qdl_getConfig('extra_d12', false), // d12 -doručenie do 12 H 1/0 povolené len pre SK
	                "sms" => qdl_getConfig('extra_sAdvice', false), // sAdvice - sms avízo povolené 1/0 povolené len pre SK
	                "call" => qdl_getConfig('extra_tAdvice', true) // tAdvice -telefonické avízo 1/0 povolené len pre SK
	            ]
			);
			
			$code = qdl_get_post_meta($post_id, '_qdl_shippingPickup_code', $single = true);
			if (!empty($code)) {
				// vyzvedne na pickup point
				$kurierOrder["services"]["PackageCentre"] = $code;
			}
			
			$kurierOrders[] = $kurierOrder;
		}
		
		try {
			$result = qdl_request('create-shipment', ['shipments' => $kurierOrders]);
		}
		catch (Exception $e) {
			$msg = $e->getMessage();
			
			$json = @json_decode($msg);
			if (!empty($json)) {
				$msg = '';
				foreach ($json as $k => $v) {
					$msg.= trim($k, '|- ').'<ul style="margin:5px 0">'; // identifikace objednávky, ale někdy prázdné
					array_walk_recursive($v, function($msgpart) use (&$msg) {
						$msg.= '<li>'.$msgpart;
					});
					$msg.= '</ul>';
				}
			}
			
			qdl_error('Objednávka #'.$post_id.' - '.$msg);
		}
		
		// $result['ids'];
		// $result['shipmentNumbers'];
		
		$i = 0;
		foreach ($rq_post_ids as $post_id)
		{
			// každá zásilka má jedno číslo, bez ohledu na počet balíků!!!!
			
			$trackingCode = null;
			if (isset($result) && isset($result['shipmentNumbers']))
			{
				$trackingCodesRes = array_shift($result['shipmentNumbers']);
				// $trackingCode = implode(';', current(current($trackingCodesRes)));
				// toto nechápu proč to mají ve dvojté array (jo, protože to je object, ale já mám arrays jenom, masakr)
				$trackingCode = implode(';', array_keys(current($trackingCodesRes)));
			}
			
			if (empty($trackingCode)) {
				qdl_error("Chyba! Server nevrátil podacie číslo k obj. #$post_id");
				exit;
			}
			elseif (!preg_match('~^[a-z0-9_\-]+$~i', $trackingCode)) {
				qdl_error("Chyba! Server nevrátil podacie číslo k obj. #$post_id - ".var_export($result, true));
				exit;
			}
			
			// uložíme do META TAGU
			qdl_update_post_meta($post_id, '_qdl_tracking_code', $trackingCode);
			qdl_update_post_meta($post_id, '_qdl_pickup_date', $pickup_date);
			qdl_update_post_meta($post_id, '_qdl_pickup_ordered', false);
			qdl_update_post_meta($post_id, '_qdl_id', $result['ids'][$i]);
			
			// přidáme k seznamu
			$imported.= ($imported == '' ? '' : ';').$trackingCode;
			
			$i++;
		}
		
		if (empty($imported)) {
			qdl_error('Žiadna objednávka sa neimportovala.');
		}
		else {
			// zobrazíme štítky pro dané balíky
			while(@ob_get_clean());
			header("Location: popup.php?action=labels&codes=".$imported."&pos=".intval(isset($_REQUEST['pos']) ? $_REQUEST['pos'] : 0));
			exit;
		}
	}
}

footer();

