/*
POUŽITÍ V ADMINISTRACI
*/
function qdl_popWin(url, w, h, pos) {
	if (typeof pos == 'undefined') pos = '';
	if (typeof w == 'undefined') w = 800;
	if (typeof h == 'undefined') h = 700;
	pos = pos.toUpperCase();
	var sw = screen.width-40; // scrollbar
	var sh = screen.height; // top bar
	if(w>sw) w=sw;
	if(h>sh) h=sh;
	var left = (sw-w)/2;
	var top = (sh-h)/3;
	if (pos == 'LEFT') left = (sw-w)/4;
	
	var nw = window.open(url, 'mzpop'+Math.random(), 'scrollbars=yes, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);
	nw.focus();
	return nw;
}

jQuery(function() {
	
	if (typeof window.isQDL != 'undefined') return console.error("QDL.js - ERROR - MULTIPLE SCRIPT INCLUSION");
	window.isQDL = 1;
	
	var $ = jQuery;
	$.fn.mzFlash = function(){
		this.fadeIn(100).fadeOut(100).fadeIn(150).fadeOut(100).fadeIn(150);
	}
	
	function getPostId(obj) {
		var id = obj.closest('[id]').attr('id'); // jednou to je TR a jednou DIV (v detailu obj.)
		if (typeof id == 'undefined') {
			alert('Chyba uložení, nenalezeno ID!');
			throw 'QDL_POST_ID_NOTFOUND';
		}
		id = id.replace('post-', '');
		return id;
	}
	
	
	//------------ AJAX OBNOVOVÁNÍ
	// PŘI ONFOCUS/ONBLUR DO OKNA, AKTUALIZUJEME AJAXEM: a) ZÁKLADNÍ BLOK V DETAILU OBJEDNÁVKY b) DATA V SEZNAMU OBJEDNÁVEK
	// protože se zobrazuje PDF štítek, tak nemůžeme prostě to obnovit přes JS jako window.opener
	var rfid;
	var rfid_tryed = 0;
	var focused = 1;
	var lastrqcall = null; // microtime
	$([window, top.window]).focus(function() {
		clearTimeout(rfid);
		rfid = setTimeout(refresh_qdl, 50);
		focused = 1;
	});
	var rfid;
	$([window, top.window]).blur(function() {
		clearTimeout(rfid);
		focused = 0;
		rfid_tryed = 0;
		rfid = setTimeout(refresh_qdl, 4000);
		// schováme tooltipy
		$('#tiptip_holder').hide();
	});
	function refresh_qdl() {
		var elids = '[data-qdl-ajaxable]';
		var ajaxable = $(elids);
		if (!ajaxable.length) return false;
		
		var now = (new Date()).getTime();
		if (lastrqcall && lastrqcall > now-1000) {
			// chce update moc rychle...
			clearTimeout(rfid);
			rfid = setTimeout(refresh_qdl, now-lastrqcall+1000);
			return false;
		}
		lastrqcall = now;
		
		console.log("QDL - check call");
		
		$.get(document.location.href, function(html){
			// máme aktuální data
			// aktualizujeme naše objekty
			var response = $('<output>').append($.parseHTML(html, document, true));
			
			var content = function(obj) {
				// dynamicky měníme "title" a "data-title" i pozici těch atributů
				return obj.html().replace(/ (data\-[^=]+|title|value)=(['"])[^\2]+\2/g, ' ').replace(/\s/g,'');
			};
			
			var changed = 0;
			
			response.find(elids).each(function(){
				var o = $(this);
				var x = o.attr('data-qdl-ajaxable');
				elid = '[data-qdl-ajaxable='+x+']';
				
				var b = $(elid);
				if (content(b) != content(o)) {
					var changed = 1;
					b.html( o.html() );
				}
			});
			// znova uděláme tooltipy
			if (changed) {
				$( document.body ).trigger( 'init_tooltips' );
			}
			
			if (!focused && rfid_tryed < 5) {
				// stále je pryč? zkus obnovení znovu
				// budeme obnovovat po 4 sekundách maximálně 5x, pak to kašleme a obnoví se to až při onfocus!!!
				rfid_tryed++;
				clearTimeout(rfid);
				rfid = setTimeout(refresh_qdl, 4000);
			}
		});
	}
	
	
	//--------- POZNÁMKA ŘIDIČI
	$(document).on('click', '.qdl_driver_note', function(){
		var btn = $(this);
		var def = btn.attr('data-value');
		var s = prompt('Zadajte poznámku pre vodiča QDL:', def);
		if (typeof s == 'undefined' || s === null) {
			return false;
		}
		else if (s != def) {
			// došlo ke změně => uložíme
			btn.prop('disabled', true);
			$.getJSON(QDL_PLUGIN_URL+'/popup.php?action_json=save_driver_note&post_id='+getPostId(btn)+'&driver_note='+encodeURIComponent(s), function(ret){
				if (typeof ret.driver_note != 'undefined') {
					var is = (ret.driver_note == '');
					btn.find('.fa-sticky-note').toggleClass('fa', !is)
					btn.find('.fa-sticky-note').toggleClass('far', is);
					btn.attr('data-value', ret.driver_note); // upravíme hodnotu
					btn.prop('disabled', false);
				} else {
					// chyba uložení
				}
			});
		}
	});
	
	
	//------------ ZADÁVANÍ HMOTNOSTI
	$(document).on('keydown', 'INPUT[data-name="qdl_packages_weight"]', function(e){
		var inp = $(this);
		if (e.which == 13)
		{
			$('#tiptip_holder').hide();
			
			// dáme focus na další pole
			var nextInp = inp.closest('TR').next('TR').find('INPUT[data-name="qdl_packages_weight"]');
			if (nextInp.length) {
				nextInp.focus();
			} else {
				inp.blur();
			}
			// blur akce provede uložení
			
			return false; // nedělej submit
		}
		else {
			inp.attr('data-qdl-changed', 1);
		}
	}).on('blur', 'INPUT[data-name="qdl_packages_weight"]', function(e){
		//--- PROVEDEME ULOŽENÍ AJAXEM
		var inp = $(this), zc = inp.attr('data-qdl-changed');
		if (typeof zc == 'undefined') return false; // nedošlo ke změně
		inp.prop('disabled', true);
		inp.removeAttr('data-qdl-changed');
		$.getJSON(QDL_PLUGIN_URL+'/popup.php?action_json=save_weight&post_id='+getPostId(inp)+'&weight='+encodeURIComponent(inp.val()), function(ret){
			if (typeof ret.weight != 'undefined') {
				inp.css('background', ret.weight == '' ? '#ffeded' : '');
				inp.val(ret.weight);
				inp.prop('disabled', false);
			} else {
				// chyba uložení
			}
		});
	});
	
	//------------- BULK ACTION
	var select = $("SELECT[name='action']#bulk-action-selector-top");
	if (select.length) {
		$('<optgroup label="QDL">')
		.append( $('<option>').val('qdl_import').text('Import zásielok a štítky') )
		.append( $('<option>').val('qdl_pickuplist').text('Tlač podacieho hárku + objednať zvoz') )
		// .append( $('<option>').val('qdl_cancel').text('Stornovat zásilky') )
		//.append( $('<option>').val('qdl_create_pickup').text('Objednať zvoz') )
		.appendTo(select);
		var form = select.closest('FORM');
		if (!form.length) alert('FORM nenalezen, knihovnu je třeba aktualizovat.');
		form.submit(function(){
			var s = select.val();
			if (s.match(/^qdl_/)) {
				var ids = ''; // post_ids oddelene carkou.
				var checkboxes = form.find('[name^="post["]'); // staré ID
				if (checkboxes.length == 0) {
					var checkboxes = form.find('INPUT[type="checkbox"][name^="id["]');
				}
				checkboxes.filter(':checked').each(function(){
					ids+= (ids == '' ? '' : ',')+this.value;
				});
				if (ids == '' && s == 'qdl_import') {
					// flash
					// potrebujeme oznacit nejake baliky nejdriv
					checkboxes.mzFlash();
					form.find('[type="submit"].button.action, #cb-select-all-1, #cb-select-all-2').mzFlash();
				} else {
					qdl_popWin(QDL_PLUGIN_URL+'/popup.php?action='+s.replace('qdl_', '')+(ids != '' ? '&post_ids='+ids : ''));
				}
				return false;
			}
		});
	}
});